Index: /branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/InfixExpressionFormatter.cs
===================================================================
--- /branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/InfixExpressionFormatter.cs	(revision 18113)
+++ /branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/InfixExpressionFormatter.cs	(revision 18114)
@@ -33,5 +33,5 @@
   public static class BaseInfixExpressionFormatter {
     public static void FormatRecursively(ISymbolicExpressionTreeNode node, StringBuilder strBuilder,
-                                          NumberFormatInfo numberFormat, string formatString, List<KeyValuePair<string, double>> constants = null) {
+                                          NumberFormatInfo numberFormat, string formatString, List<KeyValuePair<string, double>> parameters = null) {
       if (node.SubtreeCount > 1) {
         var token = GetToken(node.Symbol);
@@ -40,9 +40,9 @@
             token == "*" || token == "/" || token == "AND") {
           strBuilder.Append("(");
-          FormatRecursively(node.Subtrees.First(), strBuilder, numberFormat, formatString, constants);
+          FormatRecursively(node.Subtrees.First(), strBuilder, numberFormat, formatString, parameters);
 
           foreach (var subtree in node.Subtrees.Skip(1)) {
             strBuilder.Append(" ").Append(token).Append(" ");
-            FormatRecursively(subtree, strBuilder, numberFormat, formatString, constants);
+            FormatRecursively(subtree, strBuilder, numberFormat, formatString, parameters);
           }
 
@@ -51,5 +51,5 @@
           // handle integer powers directly
           strBuilder.Append("(");
-          FormatRecursively(node.Subtrees.First(), strBuilder, numberFormat, formatString, constants);
+          FormatRecursively(node.Subtrees.First(), strBuilder, numberFormat, formatString, parameters);
 
           var power = node.GetSubtree(1);
@@ -58,5 +58,5 @@
           } else {
             strBuilder.Append(" ").Append(token).Append(" ");
-            FormatRecursively(power, strBuilder, numberFormat, formatString, constants);
+            FormatRecursively(power, strBuilder, numberFormat, formatString, parameters);
           }
 
@@ -65,8 +65,8 @@
           // function with multiple arguments
           strBuilder.Append(token).Append("(");
-          FormatRecursively(node.Subtrees.First(), strBuilder, numberFormat, formatString, constants);
+          FormatRecursively(node.Subtrees.First(), strBuilder, numberFormat, formatString, parameters);
           foreach (var subtree in node.Subtrees.Skip(1)) {
             strBuilder.Append(", ");
-            FormatRecursively(subtree, strBuilder, numberFormat, formatString, constants);
+            FormatRecursively(subtree, strBuilder, numberFormat, formatString, parameters);
           }
 
@@ -77,15 +77,15 @@
         if (token == "-" || token == "NOT") {
           strBuilder.Append("(").Append(token).Append("(");
-          FormatRecursively(node.GetSubtree(0), strBuilder, numberFormat, formatString, constants);
+          FormatRecursively(node.GetSubtree(0), strBuilder, numberFormat, formatString, parameters);
           strBuilder.Append("))");
         } else if (token == "/") {
           strBuilder.Append("1/");
-          FormatRecursively(node.GetSubtree(0), strBuilder, numberFormat, formatString, constants);
+          FormatRecursively(node.GetSubtree(0), strBuilder, numberFormat, formatString, parameters);
         } else if (token == "+" || token == "*") {
-          FormatRecursively(node.GetSubtree(0), strBuilder, numberFormat, formatString, constants);
+          FormatRecursively(node.GetSubtree(0), strBuilder, numberFormat, formatString, parameters);
         } else {
           // function with only one argument
           strBuilder.Append(token).Append("(");
-          FormatRecursively(node.GetSubtree(0), strBuilder, numberFormat, formatString, constants);
+          FormatRecursively(node.GetSubtree(0), strBuilder, numberFormat, formatString, parameters);
           strBuilder.Append(")");
         }
@@ -96,5 +96,5 @@
           if (!varNode.Weight.IsAlmost(1.0)) {
             strBuilder.Append("(");
-            AppendConstant(strBuilder, constants, varNode.Weight, formatString, numberFormat);
+            AppendNumber(strBuilder, parameters, varNode.Weight, formatString, numberFormat);
             strBuilder.Append("*");
           }
@@ -110,5 +110,5 @@
           if (!varNode.Weight.IsAlmost(1.0)) {
             strBuilder.Append("(");
-            AppendConstant(strBuilder, constants, varNode.Weight, formatString, numberFormat);
+            AppendNumber(strBuilder, parameters, varNode.Weight, formatString, numberFormat);
             strBuilder.Append("*");
           }
@@ -124,5 +124,5 @@
           for (int i = 0; i < factorNode.Weights.Length; i++) {
             if (i > 0) strBuilder.Append(", ");
-            AppendConstant(strBuilder, constants, factorNode.Weights[i], formatString, numberFormat);
+            AppendNumber(strBuilder, parameters, factorNode.Weights[i], formatString, numberFormat);
           }
           strBuilder.Append("]");
@@ -131,5 +131,5 @@
           if (!factorNode.Weight.IsAlmost(1.0)) {
             strBuilder.Append("(");
-            AppendConstant(strBuilder, constants, factorNode.Weight, formatString, numberFormat);
+            AppendNumber(strBuilder, parameters, factorNode.Weight, formatString, numberFormat);
 
             strBuilder.Append("*");
@@ -142,10 +142,10 @@
           if (!factorNode.Weight.IsAlmost(1.0)) strBuilder.Append(")");
         } else if (node.Symbol is Number) {
-          var constNode = node as NumberTreeNode;
-          if (constants == null && constNode.Value < 0) {
-            strBuilder.Append("(").Append(constNode.Value.ToString(formatString, numberFormat))
+          var numNode = node as NumberTreeNode;
+          if (parameters == null && numNode.Value < 0) {
+            strBuilder.Append("(").Append(numNode.Value.ToString(formatString, numberFormat))
                       .Append(")"); // (-1
           } else {
-            AppendConstant(strBuilder, constants, constNode.Value, formatString, numberFormat);
+            AppendNumber(strBuilder, parameters, numNode.Value, formatString, numberFormat);
           }
         }
@@ -153,9 +153,9 @@
     }
 
-    private static void AppendConstant(StringBuilder strBuilder, List<KeyValuePair<string, double>> constants, double value, string formatString, NumberFormatInfo numberFormat) {
-      if (constants != null) {
-        string constantKey = $"c_{constants.Count}";
-        strBuilder.AppendFormat(CultureInfo.InvariantCulture, "{0}", constantKey);
-        constants.Add(new KeyValuePair<string, double>(constantKey, value));
+    private static void AppendNumber(StringBuilder strBuilder, List<KeyValuePair<string, double>> parameters, double value, string formatString, NumberFormatInfo numberFormat) {
+      if (parameters != null) {
+        string paramKey = $"c_{parameters.Count}";
+        strBuilder.AppendFormat(CultureInfo.InvariantCulture, "{0}", paramKey);
+        parameters.Add(new KeyValuePair<string, double>(paramKey, value));
       } else {
         strBuilder.Append(value.ToString(formatString, numberFormat));
@@ -204,6 +204,6 @@
     /// </summary>
     /// <param name="symbolicExpressionTree">The tree representation of the expression.</param>
-    /// <param name="numberFormat">Constant format that should be used for numeric parameters (e.g. NumberFormatInfo.InvariantInfo (default)).</param>
-    /// <param name="formatString">The format string for numeric parameters (e.g. \"G4\" to limit to 4 digits, default is \"G\")</param>
+    /// <param name="numberFormat">Number format that should be used for parameters (e.g. NumberFormatInfo.InvariantInfo (default)).</param>
+    /// <param name="formatString">The format string for parameters (e.g. \"G4\" to limit to 4 digits, default is \"G\")</param>
     /// <returns>Infix expression</returns>
     public string Format(ISymbolicExpressionTree symbolicExpressionTree, NumberFormatInfo numberFormat,
@@ -241,15 +241,15 @@
     public string Format(ISymbolicExpressionTree symbolicExpressionTree) {
       StringBuilder strBuilder = new StringBuilder();
-      var constants = new List<KeyValuePair<string, double>>();
+      var parameters = new List<KeyValuePair<string, double>>();
       BaseInfixExpressionFormatter.FormatRecursively(symbolicExpressionTree.Root.GetSubtree(0).GetSubtree(0),
-        strBuilder, NumberFormatInfo.InvariantInfo, "G", constants);
+        strBuilder, NumberFormatInfo.InvariantInfo, "G", parameters);
       strBuilder.Append($"{Environment.NewLine}{Environment.NewLine}");
 
-      int maxDigits = GetDigits(constants.Count);
-      int padding = constants.Max(x => x.Value.ToString("F12", CultureInfo.InvariantCulture).Length);
-      foreach (var constant in constants) {
-        int digits = GetDigits(Int32.Parse(constant.Key.Substring(2)));
-        strBuilder.Append($"{constant.Key}{new String(' ', maxDigits - digits)} = " +
-                          string.Format($"{{0,{padding}:F12}}", constant.Value, CultureInfo.InvariantCulture) +
+      int maxDigits = GetDigits(parameters.Count);
+      int padding = parameters.Max(x => x.Value.ToString("F12", CultureInfo.InvariantCulture).Length);
+      foreach (var param in parameters) {
+        int digits = GetDigits(int.Parse(param.Key.Substring(2)));
+        strBuilder.Append($"{param.Key}{new string(' ', maxDigits - digits)} = " +
+                          string.Format($"{{0,{padding}:F12}}", param.Value, CultureInfo.InvariantCulture) +
                           Environment.NewLine);
       }
Index: /branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionCSharpFormatter.cs
===================================================================
--- /branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionCSharpFormatter.cs	(revision 18113)
+++ /branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionCSharpFormatter.cs	(revision 18114)
@@ -310,7 +310,7 @@
 
     private void GenerateFactorSource(StringBuilder strBuilder) {
-      strBuilder.AppendLine("private static double EvaluateFactor(string factorValue, string[] factorValues, double[] constants) {");
+      strBuilder.AppendLine("private static double EvaluateFactor(string factorValue, string[] factorValues, double[] parameters) {");
       strBuilder.AppendLine("   for(int i=0;i<factorValues.Length;i++) " +
-                            "      if(factorValues[i] == factorValue) return constants[i];" +
+                            "      if(factorValues[i] == factorValue) return parameters[i];" +
                             "   throw new ArgumentException();");
       strBuilder.AppendLine("}");
Index: /branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionLatexFormatter.cs
===================================================================
--- /branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionLatexFormatter.cs	(revision 18113)
+++ /branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionLatexFormatter.cs	(revision 18114)
@@ -33,6 +33,6 @@
   [StorableType("D7186DFF-1596-4A58-B27D-974DF0D93E4F")]
   public sealed class SymbolicDataAnalysisExpressionLatexFormatter : NamedItem, ISymbolicExpressionTreeStringFormatter {
-    private readonly List<KeyValuePair<string, double>> constants;
-    private int constIndex;
+    private readonly List<KeyValuePair<string, double>> parameters;
+    private int paramIdx;
     private int targetCount;
     private int currentLag;
@@ -44,6 +44,6 @@
     private SymbolicDataAnalysisExpressionLatexFormatter(SymbolicDataAnalysisExpressionLatexFormatter original, Cloner cloner)
       : base(original, cloner) {
-      constants = new List<KeyValuePair<string, double>>(original.constants);
-      constIndex = original.constIndex;
+      parameters = new List<KeyValuePair<string, double>>(original.parameters);
+      paramIdx = original.paramIdx;
       currentLag = original.currentLag;
       targetCount = original.targetCount;
@@ -53,5 +53,5 @@
       Name = ItemName;
       Description = ItemDescription;
-      constants = new List<KeyValuePair<string, double>>();
+      parameters = new List<KeyValuePair<string, double>>();
     }
 
@@ -66,6 +66,6 @@
       try {
         StringBuilder strBuilder = new StringBuilder();
-        constants.Clear();
-        constIndex = 0;
+        parameters.Clear();
+        paramIdx = 0;
         this.targetVariable = targetVariable;
         containsTimeSeriesSymbol = symbolicExpressionTree.IterateNodesBreadth().Any(n => IsTimeSeriesSymbol(n.Symbol));
@@ -190,6 +190,6 @@
         strBuilder.Append(@" \operatorname{if}  \left( ");
       } else if (node.Symbol is INumericSymbol numNode) {
-        var numName = "c_{" + constIndex + "}";
-        constIndex++;
+        var numName = "c_{" + paramIdx + "}";
+        paramIdx++;
         var numericNode = node as INumericTreeNode;
         if (numericNode.Value.IsAlmost(1.0)) {
@@ -197,22 +197,22 @@
         } else {
           strBuilder.Append(numName);
-          constants.Add(new KeyValuePair<string, double>(numName, numericNode.Value));
+          parameters.Add(new KeyValuePair<string, double>(numName, numericNode.Value));
         }
       } else if (node.Symbol is FactorVariable) {
         var factorNode = node as FactorVariableTreeNode;
-        var constName = "c_{" + constIndex + "}";
-        strBuilder.Append(constName + " ");
+        var paramName = "c_{" + paramIdx + "}";
+        strBuilder.Append(paramName + " ");
         foreach (var e in factorNode.Symbol.GetVariableValues(factorNode.VariableName)
           .Zip(factorNode.Weights, Tuple.Create)) {
-          constants.Add(new KeyValuePair<string, double>("c_{" + constIndex + ", " + EscapeLatexString(factorNode.VariableName) + "=" + EscapeLatexString(e.Item1) + "}", e.Item2));
-        }
-        constIndex++;
+          parameters.Add(new KeyValuePair<string, double>("c_{" + paramIdx + ", " + EscapeLatexString(factorNode.VariableName) + "=" + EscapeLatexString(e.Item1) + "}", e.Item2));
+        }
+        paramIdx++;
       } else if (node.Symbol is BinaryFactorVariable) {
         var binFactorNode = node as BinaryFactorVariableTreeNode;
         if (!binFactorNode.Weight.IsAlmost((1.0))) {
-          var constName = "c_{" + constIndex + "}";
-          strBuilder.Append(constName + "  \\cdot");
-          constants.Add(new KeyValuePair<string, double>(constName, binFactorNode.Weight));
-          constIndex++;
+          var paramName = "c_{" + paramIdx + "}";
+          strBuilder.Append(paramName + "  \\cdot");
+          parameters.Add(new KeyValuePair<string, double>(paramName, binFactorNode.Weight));
+          paramIdx++;
         }
         strBuilder.Append("(" + EscapeLatexString(binFactorNode.VariableName));
@@ -222,8 +222,8 @@
         var laggedVarNode = node as LaggedVariableTreeNode;
         if (!laggedVarNode.Weight.IsAlmost(1.0)) {
-          var constName = "c_{" + constIndex + "}";
-          strBuilder.Append(constName + "  \\cdot");
-          constants.Add(new KeyValuePair<string, double>(constName, laggedVarNode.Weight));
-          constIndex++;
+          var paramName = "c_{" + paramIdx + "}";
+          strBuilder.Append(paramName + "  \\cdot");
+          parameters.Add(new KeyValuePair<string, double>(paramName, laggedVarNode.Weight));
+          paramIdx++;
         }
         strBuilder.Append(EscapeLatexString(laggedVarNode.VariableName));
@@ -233,8 +233,8 @@
         var varNode = node as VariableTreeNode;
         if (!varNode.Weight.IsAlmost((1.0))) {
-          var constName = "c_{" + constIndex + "}";
-          strBuilder.Append(constName + "  \\cdot");
-          constants.Add(new KeyValuePair<string, double>(constName, varNode.Weight));
-          constIndex++;
+          var paramName = "c_{" + paramIdx + "}";
+          strBuilder.Append(paramName + "  \\cdot");
+          parameters.Add(new KeyValuePair<string, double>(paramName, varNode.Weight));
+          paramIdx++;
         }
         strBuilder.Append(EscapeLatexString(varNode.VariableName));
@@ -270,12 +270,12 @@
       } else if (node.Symbol is VariableCondition) {
         var conditionTreeNode = node as VariableConditionTreeNode;
-        var constName = "c_{" + constants.Count + "}";
-        string p = @"1 /  1 + \exp  - " + constName + " ";
-        constants.Add(new KeyValuePair<string, double>(constName, conditionTreeNode.Slope));
-        constIndex++;
-        var const2Name = "c_{" + constants.Count + @"}";
+        var paramName = "c_{" + parameters.Count + "}";
+        string p = @"1 /  1 + \exp  - " + paramName + " ";
+        parameters.Add(new KeyValuePair<string, double>(paramName, conditionTreeNode.Slope));
+        paramIdx++;
+        var const2Name = "c_{" + parameters.Count + @"}";
         p += @" \cdot " + EscapeLatexString(conditionTreeNode.VariableName) + LagToString(currentLag) + " - " + const2Name + "   ";
-        constants.Add(new KeyValuePair<string, double>(const2Name, conditionTreeNode.Threshold));
-        constIndex++;
+        parameters.Add(new KeyValuePair<string, double>(const2Name, conditionTreeNode.Threshold));
+        paramIdx++;
         strBuilder.Append(@" \left( " + p + @"\cdot ");
       } else {
@@ -378,12 +378,12 @@
       } else if (node.Symbol is VariableCondition) {
         var conditionTreeNode = node as VariableConditionTreeNode;
-        var const1Name = "c_{" + constants.Count + "}";
+        var const1Name = "c_{" + parameters.Count + "}";
         string p = @"1 / \left( 1 + \exp \left( - " + const1Name + " ";
-        constants.Add(new KeyValuePair<string, double>(const1Name, conditionTreeNode.Slope));
-        constIndex++;
-        var const2Name = "c_{" + constants.Count + "}";
+        parameters.Add(new KeyValuePair<string, double>(const1Name, conditionTreeNode.Slope));
+        paramIdx++;
+        var const2Name = "c_{" + parameters.Count + "}";
         p += @" \cdot " + EscapeLatexString(conditionTreeNode.VariableName) + LagToString(currentLag) + " - " + const2Name + " \right) \right) \right)   ";
-        constants.Add(new KeyValuePair<string, double>(const2Name, conditionTreeNode.Threshold));
-        constIndex++;
+        parameters.Add(new KeyValuePair<string, double>(const2Name, conditionTreeNode.Threshold));
+        paramIdx++;
         strBuilder.Append(@" +  \left( 1 - " + p + @" \right) \cdot ");
       } else {
@@ -481,12 +481,12 @@
           .AppendLine("\\begin{align*}")
           .AppendLine("\\nonumber");
-        // output all constant values
-        if (constants.Count > 0) {
-          foreach (var constant in constants) {
+        // output all parameter values
+        if (parameters.Count > 0) {
+          foreach (var param in parameters) {
             // replace "." with ".&" to align decimal points
-            var constStr = string.Format(System.Globalization.NumberFormatInfo.InvariantInfo, "{0:G5}", constant.Value);
-            if (!constStr.Contains(".")) constStr = constStr + ".0";
-            constStr = constStr.Replace(".", "&.");  // fix problem in rendering of aligned expressions
-            strBuilder.Append(constant.Key + "& = & " + constStr);
+            var paramStr = string.Format(System.Globalization.NumberFormatInfo.InvariantInfo, "{0:G5}", param.Value);
+            if (!paramStr.Contains(".")) paramStr = paramStr + ".0";
+            paramStr = paramStr.Replace(".", "&.");  // fix problem in rendering of aligned expressions
+            strBuilder.Append(param.Key + "& = & " + paramStr);
             strBuilder.Append(@"\\");
           }
Index: /branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/ArithmeticExpressionGrammar.cs
===================================================================
--- /branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/ArithmeticExpressionGrammar.cs	(revision 18113)
+++ /branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/ArithmeticExpressionGrammar.cs	(revision 18114)
@@ -52,10 +52,9 @@
       number.MinValue = -20;
       number.MaxValue = 20;
-      var constant = new Constant();
-      var variableSymbol = new HeuristicLab.Problems.DataAnalysis.Symbolic.Variable();
+      var variableSymbol = new Variable();
       var binFactorVariableSymbol = new BinaryFactorVariable();
       var factorVariableSymbol = new FactorVariable();
 
-      var allSymbols = new List<Symbol>() { add, sub, mul, div, number, constant, variableSymbol, binFactorVariableSymbol, factorVariableSymbol };
+      var allSymbols = new List<Symbol>() { add, sub, mul, div, number, variableSymbol, binFactorVariableSymbol, factorVariableSymbol };
       var functionSymbols = new List<Symbol>() { add, sub, mul, div };
 
@@ -67,5 +66,4 @@
       }
       SetSubtreeCount(number, 0, 0);
-      SetSubtreeCount(constant, 0, 0);
       SetSubtreeCount(variableSymbol, 0, 0);
       SetSubtreeCount(binFactorVariableSymbol, 0, 0);
Index: /branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/FullFunctionalExpressionGrammar.cs
===================================================================
--- /branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/FullFunctionalExpressionGrammar.cs	(revision 18113)
+++ /branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/FullFunctionalExpressionGrammar.cs	(revision 18114)
@@ -121,5 +121,5 @@
       number.MinValue = -20;
       number.MaxValue = 20;
-      var variableSymbol = new HeuristicLab.Problems.DataAnalysis.Symbolic.Variable();
+      var variableSymbol = new Variable();
       var binFactorVariable = new BinaryFactorVariable();
       var factorVariable = new FactorVariable();
@@ -130,9 +130,7 @@
       autoregressiveVariable.Enabled = false;
 
-      var constant = new Constant();
-
       var allSymbols = new List<Symbol>() { add, sub, mul, div, aq, mean, abs, sin, cos, tan, log, square, cube, pow, sqrt, cubeRoot, root, exp, tanh,
         airyA, airyB, bessel, cosineIntegral, dawson, erf, expIntegralEi, fresnelCosineIntegral, fresnelSineIntegral, gamma, hypCosineIntegral, hypSineIntegral, norm, psi, sineIntegral,
-        @if, gt, lt, and, or, not,xor, timeLag, integral, derivative, number, constant, variableSymbol, binFactorVariable, factorVariable, laggedVariable,autoregressiveVariable, variableCondition };
+        @if, gt, lt, and, or, not,xor, timeLag, integral, derivative, number, variableSymbol, binFactorVariable, factorVariable, laggedVariable,autoregressiveVariable, variableCondition };
       var unaryFunctionSymbols = new List<Symbol>() { abs, square, sqrt, cube, cubeRoot, sin, cos, tan, log, exp, tanh, not, timeLag, integral, derivative,
         airyA, airyB, bessel, cosineIntegral, dawson, erf, expIntegralEi, fresnelCosineIntegral, fresnelSineIntegral, gamma, hypCosineIntegral, hypSineIntegral, norm, psi, sineIntegral
@@ -141,5 +139,5 @@
       var binaryFunctionSymbols = new List<Symbol>() { pow, root, gt, lt, aq, variableCondition };
       var ternarySymbols = new List<Symbol>() { add, sub, mul, div, mean, and, or, xor };
-      var terminalSymbols = new List<Symbol>() { variableSymbol, binFactorVariable, factorVariable, number, constant, laggedVariable, autoregressiveVariable };
+      var terminalSymbols = new List<Symbol>() { variableSymbol, binFactorVariable, factorVariable, number, laggedVariable, autoregressiveVariable };
 
       foreach (var symb in allSymbols)
Index: /branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/LinearScalingGrammar.cs
===================================================================
--- /branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/LinearScalingGrammar.cs	(revision 18113)
+++ /branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/LinearScalingGrammar.cs	(revision 18114)
@@ -69,5 +69,4 @@
       number.MinValue = -20;
       number.MaxValue = 20;
-      var constant = new Constant();
       var variableSymbol = new Variable();
 
@@ -79,5 +78,5 @@
       //all other symbols
       var allSymbols = new List<Symbol> {
-        add, sub, mul, div, number, constant, variableSymbol, sin, cos, tan, log, square, sqrt, cube, cbrt, exp,
+        add, sub, mul, div, number, variableSymbol, sin, cos, tan, log, square, sqrt, cube, cbrt, exp,
         tanh, aq, abs
       };
@@ -87,5 +86,5 @@
       var realValueSymbols = new List<Symbol> {
          add, sub, mul, div, sin, cos, tan, tanh, exp, log, aq, abs, square, cube, sqrt, cbrt,
-         variableSymbol, number, constant
+         variableSymbol, number
         };
 
Index: /branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/TypeCoherentExpressionGrammar.cs
===================================================================
--- /branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/TypeCoherentExpressionGrammar.cs	(revision 18113)
+++ /branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/TypeCoherentExpressionGrammar.cs	(revision 18114)
@@ -108,5 +108,4 @@
       number.MinValue = -20;
       number.MaxValue = 20;
-      var constant = new Constant();
       var variableSymbol = new Variable();
       var binFactorVariable = new BinaryFactorVariable();
@@ -122,5 +121,5 @@
       var specialFunctions = new GroupSymbol(SpecialFunctionsName, new List<ISymbol> { abs, airyA, airyB, bessel, cosineIntegral, dawson, erf, expIntegralEi,
         fresnelCosineIntegral,fresnelSineIntegral,gamma,hypCosineIntegral,hypSineIntegral,norm, psi, sineIntegral, analyticalQuotient});
-      var terminalSymbols = new GroupSymbol(TerminalsName, new List<ISymbol> { number, constant, variableSymbol, binFactorVariable, factorVariable });
+      var terminalSymbols = new GroupSymbol(TerminalsName, new List<ISymbol> { number, variableSymbol, binFactorVariable, factorVariable });
       var realValuedSymbols = new GroupSymbol(RealValuedSymbolsName, new List<ISymbol>() { arithmeticSymbols, trigonometricSymbols, exponentialAndLogarithmicSymbols, specialFunctions, terminalSymbols });
 
Index: /branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Hashing/SymbolicExpressionTreeHash.cs
===================================================================
--- /branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Hashing/SymbolicExpressionTreeHash.cs	(revision 18113)
+++ /branches/3140_NumberSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Hashing/SymbolicExpressionTreeHash.cs	(revision 18114)
@@ -66,6 +66,6 @@
       var symbol = node.Symbol;
       var name = symbol.Name;
-      if (node is NumberTreeNode constantNode) {
-        name = strict ? constantNode.Value.ToString() : symbol.Name;
+      if (node is NumberTreeNode numNode) {
+        name = strict ? numNode.Value.ToString() : symbol.Name;
       } else if (node is VariableTreeNode variableNode) {
         name = strict ? variableNode.Weight.ToString() + variableNode.VariableName : variableNode.VariableName;
@@ -222,7 +222,7 @@
             variableTreeNode.VariableName = variable.VariableName;
             variableTreeNode.Weight = variable.Weight;
-          } else if (node.Data is NumberTreeNode @const) {
-            var constantTreeNode = (NumberTreeNode)treeNodes[i];
-            constantTreeNode.Value = @const.Value;
+          } else if (node.Data is NumberTreeNode existingNumNode) {
+            var newNumNode = (NumberTreeNode)treeNodes[i];
+            newNumNode.Value = existingNumNode.Value;
           }
           continue;
@@ -272,5 +272,5 @@
     }
 
-    // simplify multiplications by reducing constants and div terms
+    // simplify multiplications by reducing numbers and div terms
     public static void SimplifyMultiplication(ref HashNode<ISymbolicExpressionTreeNode>[] nodes, int i) {
       var node = nodes[i];
@@ -285,12 +285,12 @@
 
         var symbol = child.Data.Symbol;
-        if (child.Data is NumberTreeNode firstConst) {
-          // fold sibling constant nodes into the first constant
+        if (child.Data is NumberTreeNode firstNum) {
+          // fold sibling number nodes into the first number
           for (int k = j + 1; k < children.Length; ++k) {
             var sibling = nodes[children[k]];
-            if (sibling.Data is NumberTreeNode otherConst) {
+            if (sibling.Data is NumberTreeNode otherNum) {
               sibling.Enabled = false;
               node.Arity--;
-              firstConst.Value *= otherConst.Value;
+              firstNum.Value *= otherNum.Value;
             } else {
               break;
@@ -298,11 +298,11 @@
           }
         } else if (child.Data is VariableTreeNode variable) {
-          // fold sibling constant nodes into the variable weight
+          // fold sibling number nodes into the variable weight
           for (int k = j + 1; k < children.Length; ++k) {
             var sibling = nodes[children[k]];
-            if (sibling.Data is NumberTreeNode constantNode) {
+            if (sibling.Data is NumberTreeNode numNode) {
               sibling.Enabled = false;
               node.Arity--;
-              variable.Weight *= constantNode.Value;
+              variable.Weight *= numNode.Value;
             } else {
               break;
@@ -328,8 +328,8 @@
         }
 
-        if (node.Arity == 0) { // if everything is simplified this node becomes constant
-          var constantTreeNode = number.CreateTreeNode<NumberTreeNode>();
-          constantTreeNode.Value = 1;
-          nodes[i] = constantTreeNode.ToHashNode();
+        if (node.Arity == 0) { // if everything is simplified this node becomes a number
+          var numNode = number.CreateTreeNode<NumberTreeNode>();
+          numNode.Value = 1;
+          nodes[i] = numNode.ToHashNode();
         } else if (node.Arity == 1) { // when i have only 1 arg left i can skip this node
           node.Enabled = false;
@@ -353,7 +353,7 @@
           }
         }
-        var constantTreeNode = number.CreateTreeNode<NumberTreeNode>();
-        constantTreeNode.Value = v;
-        nodes[i] = constantTreeNode.ToHashNode();
+        var numNode = number.CreateTreeNode<NumberTreeNode>();
+        numNode.Value = v;
+        nodes[i] = numNode.ToHashNode();
         return;
       }
@@ -368,7 +368,7 @@
         }
         if (node.Arity == 0) {
-          var constantTreeNode = number.CreateTreeNode<NumberTreeNode>();
-          constantTreeNode.Value = 1; // x / x = 1
-          nodes[i] = constantTreeNode.ToHashNode();
+          var numNode = number.CreateTreeNode<NumberTreeNode>();
+          numNode.Value = 1; // x / x = 1
+          nodes[i] = numNode.ToHashNode();
         }
       }
@@ -376,5 +376,5 @@
 
     public static void SimplifyUnaryNode(ref HashNode<ISymbolicExpressionTreeNode>[] nodes, int i) {
-      // check if the child of the unary node is a constant, then the whole node can be simplified
+      // check if the child of the unary node is a number, then the whole node can be simplified
       var parent = nodes[i];
       var child = nodes[i - 1];
